/* proto.h
 * David Lutz
 * Jason Hunter
 * Modified by Werner Zimmermann, Oct. 96
 *
 * This header file contains the function prototypes
 */

/* readdisk.c */
void    convert(unsigned long x, unsigned int *head, unsigned int *track, \
		unsigned int *sector, unsigned int *offset);
void    examine_drive(void);
int     readdisk( unsigned char *buf, unsigned long loc, size_t size );

/* super.c */
int     load_super( void );
void    print_super( void );

/* group.c */
int     load_groups( void );
void    print_groups( void );

/* inode.c */
inode   *load_inode( unsigned long inode_no );
void    print_inode( inode *i, unsigned long inode_no);
long    block_list( inode *i, int pflg );
int     read_inode( inode *i, byte *buffer, size_t size, char ctrl );
void    print_blocks( inode *i );

/* dir.c */
unsigned long eatpath( char *path, char *inode_name, char ctrl);
void          list_dir( inode *i, char *path );
char          *build_mode( inode *i );
unsigned long search_dir( inode *i, char *str, char *inode_name, char ctrl);
